## mingw-w64-med-4.1.1-9.src.tar.zst

=== include/CMakeLists.txt ===
ADD_SUBDIRECTORY(2.3.6)

CONFIGURE_FILE(med.h.in ${CMAKE_CURRENT_BINARY_DIR}/med.h @ONLY)
CONFIGURE_FILE(med_utils.h.in ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h @ONLY)
CONFIGURE_FILE(med_parameter.hf.in ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf @ONLY)

CONFIGURE_FILE(H5public_extract.h.in ${CMAKE_CURRENT_BINARY_DIR}/H5public_extract.h @ONLY)

SET(medC_HEADERS_H
  ${CMAKE_CURRENT_BINARY_DIR}/med.h
  ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h
  medlibrary.h
  medfile.h
  medmesh.h
  medfamily.h
  medfield.h
  medprofile.h
  medlocalization.h
  medparameter.h
  medequivalence.h
  medinterp.h
  medfilter.h
  medsubdomain.h
  medstructelement.h
  medlink.h
  med_err.h
  med_exit_if.h
  med_proto.h
  medC_win_dll.h
  MEDerreur.hxx
  med_filechar.h
)

SET(medF_HEADERS_H
  med.hf    
  med.hf77
  med.hf90
  ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf
)

INSTALL(FILES ${medC_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})
INSTALL(FILES ${medF_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})

=== src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS})

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targes built in the sub-directories:
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-DmedC_EXPORTS)
ENDIF()
  
# Specific include logic - see CMakeLists.txt inside:
ADD_SUBDIRECTORY("2.3.6")

# Important: the following include comes AFTER the subdirectory 2.3.6
# to ensure the include works properly (2.3.6 includes are specific)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include 
    ${PROJECT_SOURCE_DIR}/include)

# Get pure C intermediary targets:
ADD_SUBDIRECTORY(hdfi)
ADD_SUBDIRECTORY(ci)
ADD_SUBDIRECTORY(misc)

IF(CMAKE_Fortran_COMPILER_WORKS)
  # Build intermediate targets _cfi, _cfi_static and _fi:
  ADD_SUBDIRECTORY(cfi)
  ADD_SUBDIRECTORY(fi)

  SET(medfort_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236> 
    $<TARGET_OBJECTS:_cfi>
  )
  
  SET(medfort_static_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236_static> 
    $<TARGET_OBJECTS:_cfi_static>
  )
ENDIF()

SET(medC_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236>
  $<TARGET_OBJECTS:_hdfi236>
  $<TARGET_OBJECTS:_misc236>
  $<TARGET_OBJECTS:_med236>
  $<TARGET_OBJECTS:_ci>
  $<TARGET_OBJECTS:_misc>
  $<TARGET_OBJECTS:_hdfi>  
)

SET(medC_static_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236_static>
  $<TARGET_OBJECTS:_hdfi236_static>
  $<TARGET_OBJECTS:_misc236_static>
  $<TARGET_OBJECTS:_med236_static>
  $<TARGET_OBJECTS:_ci_static>
  $<TARGET_OBJECTS:_misc_static>
  $<TARGET_OBJECTS:_hdfi_static>  
)

########################### Pure C stuff ###################################
############################################################################

### Installation preparation:
SET(_export_group "medfileTargets")

######### Shared Libraries ##########
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medC SHARED ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC PROPERTIES
    SOVERSION 11
    VERSION   11.1.1)
  TARGET_LINK_LIBRARIES(medC ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC NOGDI)
  
  INSTALL(TARGETS medC EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})  
ENDIF()

######### Static Libraries ##########
##
## Target names are suffixed with "_static" but file 
## names remain the same.
 
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medC_static STATIC ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC_static PROPERTIES OUTPUT_NAME medC)
  TARGET_LINK_LIBRARIES(medC_static ${HDF5_LIBS} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC_static NOGDI)
  
  INSTALL(TARGETS medC_static EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})
ENDIF()

########################### Fortran stuff ###################################
#############################################################################
IF(CMAKE_Fortran_COMPILER_WORKS)
  
  ######### Shared Libraries ##########
  IF(MEDFILE_BUILD_SHARED_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap SHARED ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap PROPERTIES
      SOVERSION 11
      VERSION   11.1.1)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    INSTALL(TARGETS medfwrap EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})

    # Add Shared MED library
    ADD_LIBRARY(med SHARED MEDiterators.c)
    SET_TARGET_PROPERTIES(med PROPERTIES
      SOVERSION 11
      VERSION   11.1.1)
    TARGET_LINK_LIBRARIES(medfwrap medC)
    TARGET_LINK_LIBRARIES(med medfwrap)    
   
    # Install only the resulting library:
    INSTALL(TARGETS med EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})
  ENDIF()

  ######### Static Libraries ##########
  ##
  ## Target names are suffixed with "_static" but file 
  ## names remain the same.
  IF(MEDFILE_BUILD_STATIC_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap_static STATIC ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap_static PROPERTIES OUTPUT_NAME medfwrap)
    TARGET_LINK_LIBRARIES(medfwrap_static medC_static)
    INSTALL(TARGETS medfwrap_static EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})
    
    # Add Static MED library
    ADD_LIBRARY(med_static STATIC MEDiterators.c)
    SET_TARGET_PROPERTIES(med_static PROPERTIES OUTPUT_NAME med)
    TARGET_LINK_LIBRARIES(med_static medfwrap_static)

    # Install only the resulting library:  
    INSTALL(TARGETS med_static EXPORT ${_export_group} DESTINATION lib${LIB_SUFFIX})
  ENDIF()
  
ENDIF(CMAKE_Fortran_COMPILER_WORKS)

=== PKGBUILD ===
# Maintainer: Alexander F. Rodseth <xyproto@archlinux.org>
# Contributor: Guilhem Saurel <guilhem@saurel.me>
# Contributor: Michel Zou
# Contributor: Oliver Goethel
# Contributor: Rafal Brzegowy <3rav@hotmail.com>

_realname=med
pkgbase=mingw-w64-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_realname}
pkgver=4.1.1
pkgrel=9
pkgdesc="Generic pre- and post-processing platform for numerical simulation (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://www.salome-platform.org/"
license=('spdx:LGPL-3.0-or-later AND GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-hdf5"
         $([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-tk")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* && ${MSYSTEM} != *64 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-fc")
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("http://files.salome-platform.org/Salome/other/${_realname}-${pkgver}.tar.gz"
        "hdf5-1.14.patch"
        "bin-dest.patch")
sha256sums=('dc2b5d54ebf0666e3ff2e974041d2ab0da906061323537023ab165d573389dd0'
            'd2d711adc32083041c85906e84592873b1ab6c54b02670b57678a33edce10fa9'
            '75f078af79b58d41ccc6f4a2ccf1a0ab4aa50365600d279ef2466456a3bfa67f')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}
# =========================================== #

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}_SRC"
  apply_patch_with_msg \
    hdf5-1.14.patch \
    bin-dest.patch
  sed -i 's/if H5_VERS_MINOR > 10/if 0/g' src/ci/MEDfileCompatibility.c
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CFLAGS+=" -DH5_USE_110_API -Wno-implicit-function-declaration"

  # Static Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -GNinja \
    "${_extra_config[@]}" \
    -DMEDFILE_BUILD_SHARED_LIBS=OFF \
    -DMEDFILE_BUILD_STATIC_LIBS=ON \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DMEDFILE_BUILD_PYTHON=OFF \
    -DMEDFILE_BUILD_TESTS=OFF \
    -DMEDFILE_INSTALL_DOC=OFF \
    ../${_realname}-${pkgver}_SRC
  "${MINGW_PREFIX}"/bin/cmake --build .

  # Shared Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -GNinja \
    "${_extra_config[@]}" \
    -DMEDFILE_BUILD_SHARED_LIBS=ON \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DMEDFILE_BUILD_PYTHON=OFF \
    -DMEDFILE_BUILD_TESTS=OFF \
    -DMEDFILE_INSTALL_DOC=OFF \
    ../${_realname}-${pkgver}_SRC
  "${MINGW_PREFIX}"/bin/cmake --build .
}

package() {
  # Static Install
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  # Shared Install
  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}_SRC/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/${_realname}-${pkgver}_SRC/COPYING.LESSER" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING.LESSER"
}
